package org.rcisoft.business.device.assets.service;

import org.rcisoft.business.device.assets.entity.BusDevice;
import org.rcisoft.business.device.assets.vo.DeviceAssetStatisticVo;
import org.rcisoft.business.device.assets.vo.DeviceParamsVo;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.aop.PageUtil;

import javax.servlet.http.HttpServletResponse;
import java.util.List;
import java.util.Map;

/**
 * Created by  on 2018-4-12 15:33:23.
 */
public interface BusDeviceService {

    /**
    * 保存 
    * @param busDevice
    * @return
    */
    PersistModel save(BusDevice busDevice);

    /**
    * 修改 
    * @param busDevice
    * @return
    */
    PersistModel merge(BusDevice busDevice);

    /**
     * 删除
     * @param busDevice
     * @return
     */
    PersistModel delete(String devid);

    /**
    * 根据id查询 
    * @param id
    * @return
    */
    List<BusDevice> findById(String id);

    /**
     * 根据编号查询
     * @param devNum
     * @return
     */
    public List<Map<String,Object>> findByDevNum(String devNum);

    /**
    * 分页查询 
    * @param busDevice
    * @return
    */
    List<Map<String,Object>> findAllByPagination(PageUtil<BusDevice> paginationUtility,
                                                 BusDevice busDevice);

    /**
     *通过项目id与子系统id获取系统中所有的设备
     * @param proId 项目id
     * @param sysId 系统id
     */
    List<DeviceAssetStatisticVo> getDevicesBySysId(String sysId, String proId);

    /**
     * 通过项目id获取项目名称
     * @param proId
     * @return
     */
    String getProNameByProId(String proId);

    /**
     * 通过系统id获取系统名称
     * @param sysId
     * @return
     */
    String getSysNameBySysId(String sysId);

    /**
     * 定时任务调用，更新设备的运行时长
     * @return
     */
    Integer addRunTime();

    /**
     * 参数库导出
     * @param response
     */
    void downloadExcel(HttpServletResponse response, List<DeviceParamsVo> list);

    /**
     * 生成设备二维码
     * @param devNum 设备编号
     * @return
     */
    PersistModel generateCode(String devNum);
}
