package org.rcisoft.business.device.inspection.service.impl;

import freemarker.template.SimpleDate;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.io.FileUtils;
import org.rcisoft.business.device.inspection.dao.InspectionRepository;
import org.rcisoft.business.device.inspection.service.InspectionService;
import org.rcisoft.business.evaluate.analysis.entity.BusReport;
import org.rcisoft.common.constants.DeviceInspectFlagConstant;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import javax.servlet.http.HttpServletResponse;
import java.io.File;
import java.io.IOException;
import java.io.OutputStream;
import java.net.URLEncoder;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * Created by  on 2018-4-18 15:41:54.
 */
@Service
@Transactional(readOnly = true,propagation = Propagation.NOT_SUPPORTED)
@Slf4j
public class InspectionServiceImpl implements InspectionService {

    @Autowired
    private InspectionRepository inspectionRepository;
    @Value("${filepath.qrcode}")
    private String filepath;

    @Override
    public List<Map<String, Object>> listTheLastInspectionInfomatinByProIdAndFlag(String proId) {
        String flag = DeviceInspectFlagConstant.THE_LAST_FLAG;
        return inspectionRepository.listTheLastInspectionInfomatinByProIdAndFlag(proId,flag);
    }

    @Override
    public List<Map<String, Object>> listAllInspectionInfomatinByProIdAndDevNum(String proId, String devNum,String mon) {
        if(mon==null || mon.equals("")){
            SimpleDateFormat simple = new SimpleDateFormat("yyyy-MM");
            mon = simple.format(new Date());
        }
        return inspectionRepository.listAllInspectionInfomatinByProIdAndDevNum(proId, devNum,mon);
    }

    @Override
    public void download(HttpServletResponse response, String filename) {
        String path = filepath+filename;
        try(OutputStream outputStream = response.getOutputStream()) {
            //获取文件字节
            byte[] bytes = FileUtils.readFileToByteArray(new File(path));
            //设置下载头
            response.setHeader("Content-disposition", "attachment;filename=" + URLEncoder.encode(filename, "iso-8859-1"));
            outputStream.write(bytes);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
