package org.rcisoft.business.device.maintenance.service;

import org.rcisoft.business.device.maintenance.entity.BusDevService;

import java.util.List;
import java.util.Map;

/**
 * The interface Maintenance service.
 *
 * @author: WangXinYu
 * @describe: TODO
 * @create: 2018年04月20日 15:31
 */
public interface MaintenanceService {

    /**
     * Save bus dev service int.
     * 新增 维修记录
     *
     * @param busDevService the bus dev service
     * @return the int
     */
    int saveBusDevService(BusDevService busDevService);

    /**
     * Update bus dev service int.
     * 更新 维修记录
     * @param busDevService the bus dev service
     * @return the int
     */
    int updateBusDevService(BusDevService busDevService);

    /**
     * Delete bus dev service by id int.
     * 删除维修记录
     *
     * @param id the id
     * @return the int
     */
    int deleteBusDevServiceById(String id);

    /**
     * List device category list.
     * 查询所有的设备种类
     *
     * @return the list
     */
    List<Map<String,Object>> listDeviceCategory();

    /**
     * List device by tp id list.
     * 根据设备种类id查询该种类的设备
     *
     * @param tpID the tp id
     * @return the list
     */
    List<Map<String,Object>> listDeviceByTpId(String tpID);

    /**
     * List bus device service by date list.
     * 根据日期（YYYY-mm-dd格式） 查询维修记录
     *
     * @param date the date
     * @return the list
     */
    List<Map<String,Object>> listBusDevServiceByDate(String date);


    /**
     * List bus dev service by year list.
     * 根据年份 查询维修记录
     *
     * @param year the year
     * @return the list
     */
    List<Map<String,Object>> listBusDevServiceByYear(String year);


    /**
     * List dev date list.
     * 使用年份查询存在维护记录的 日期
     *
     * @param year the year
     * @return the list
     */
    List<Map<String, Object>> listDevDate(String year);
}
