package org.rcisoft.business.device.report.controller;

import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.rcisoft.business.device.report.service.ReportService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletResponse;

/**
 * Created by JiChao on 2018/5/3.
 * 设备维护--设备报表
 */
@RestController
@RequestMapping("report")
public class ReportController {

    @Autowired
    private ReportService reportServiceImpl;

    @ApiOperation(value="下载文件", notes="下载文件")
    @ApiImplicitParams({@ApiImplicitParam(name = "proId", value = "项目主键", required = true, dataType = "字符串"),
            @ApiImplicitParam(name = "year", value = "年", required = true, dataType = "数字"),
            @ApiImplicitParam(name = "month", value = "月", required = true, dataType = "数字"),
            @ApiImplicitParam(name = "day", value = "日", required = true, dataType = "数字")})
    @RequestMapping("/download")
    public void download(HttpServletResponse response, @RequestParam String proId, Integer year, Integer month, Integer day) {
        reportServiceImpl.download(response, proId, year, month, day);
    }
}
