package org.rcisoft.business.device.report.dao;

import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;
import org.rcisoft.business.device.report.entity.Original;
import org.rcisoft.business.device.report.entity.Report;
import org.rcisoft.business.device.report.vo.Params;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * Created by JiChao on 2018/5/3.
 */
@Repository
public interface ReportRepository {

    /**
     * 获取设备列表，原始格式
     * @param params
     * @return
     */
    @Select("<script>select b.DEV_NUM,b.DEV_NM,bp.PARAM,dp.P_SOURCE,dp.PARAM_NM " +
            "from bus_device_param bp,bus_devicetp_param dp,bus_device b " +
            "where bp.PARAM_CODE=dp.PARAM_CODE and b.PRO_ID=dp.PRO_ID and bp.DEV_NUM=b.DEV_NUM and b.PRO_ID=#{proId}" +
            "order by b.DEV_NUM,dp.P_SOURCE</script>")
    @ResultMap(value = "report")
    List<Report> reportList(Params params);

    /**
     * 获取数据
     * @param params
     * @return
     */
    @Select("<script>select t.DEV_NUM,t.TM,t.ORIGINAL_STR,s.SENSOR_JSON from total_original t,total_sensor s " +
            "where t.TM=s.TM and t.PRO_ID=s.PRO_ID and t.WATER_V is null and t.ELEC_V is null and t.GAS_V is null " +
            "and t.PRO_ID=#{proId} and date_format(t.TM, '%Y-%c-%e')=#{time} " +
            "order by t.DEV_NUM,t.TM</script>")
    @ResultMap(value = "original")
    List<Original> originalList(Params params);

}
